var CHECK_TYPE_SALE = 0,
    CHECK_TYPE_RETURN = 1;

var getCheckOperationType = function (type) {
    return (type == CHECK_TYPE_SALE) ? "Продажа" :
        (type == CHECK_TYPE_RETURN) ? "Возврат" : "";
}

var showChecksListView = function(){
    var view = new kendo.View($('#checksListViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    $("#refreshButton").kendoButton({
        icon: "refresh",
        click: function(){
            reloadCheckList();
        }
    });

    /*-------------------Чек--------------------*/
    $("#checksListGrid").kendoGrid({
        filterable: {
            extra: false,
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:",
                selectedItemsFormat: "Выбрано {0} элементов",
                checkAll: "Выбрать Всё"
            },
            operators: {
                string: {
                    contains: "Содержит",
                    eq: "Равно",
                    neq: "Не равно",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                },
                date: {
                    gte: "после или равна",
                    gt: "после",
                    lte: "до или равна",
                    lt: "до"
                }
            }
        },
        groupable: true,
        resizable: true,
        sortable: true,
        pageable: {
            pageSizes: true,
            pageSize : 20
        },
        columns: [
            { field: "cr_no", title: "Номер кассы", width: 130 },
            { field: "shift_no", title: "Номер смены", width: 130 },
            { field: "bill_no", title: "Номер чека", width: 120 },
            { field: "cr_date", title: "Время на кассе", width: 160,
                format: "{0: dd.MM.yyyy HH:mm:ss}",
                filterable: {
                    extra: true,
                    ui: "datetimepicker"
                }
            },
            { field: "device_date", title: "Время на устройстве", width: 160, hidden: true,
                format: "{0: dd.MM.yyyy HH:mm:ss}",
                filterable: {
                    extra: true,
                    ui: "datetimepicker"
                }
            },
            { field: "oper_type", title: "Тип", width: 120, filterable: false,
                template: function(dataItem) {
                    return dataItem.oper_type != undefined ?
                        getCheckOperationType(dataItem.oper_type) : "";
                }
            },
            { field: "positions_cnt", title: "Всего позиций в чеке", width: 150 },
            { field: "alc_positions_cnt", title: 'Алкогольных позиций в чеке', width: 150 },
            { field: "non_alc_positions_cnt", title: "Остальных позиций в чеке", width: 150, hidden: true },
            { field: "total_sum", title: "Общая сумма", format: "{0:c}", width: 150 },
            { field: "total_discount", title: "Общая скидка", format: "{0:c}", width: 200, hidden: true },
            { field: "total_extras", title: "Общая наценка", format: "{0:c}", width: 200, hidden: true },
            { field: "payment_by_cash", title: "Оплата наличными", format: "{0:c}", width: 200, hidden: true },
            { field: "payment_by_card", title: "Оплата картой", format: "{0:c}", width: 200, hidden: true},
            { field: "utm_state", title: "Статус чека", format: "{0:c}", width: 200, hidden: true },
            { field: "url", title: "URL", width: 200, hidden: true }
        ],
        detailTemplate: kendo.template($("#checkPositionTemplate").html()),
        detailInit: detailInit,
        dataBound: function() {
            this.expandRow(this.tbody.find("tr.k-master-row").first());
        },
        dataBinding: function() {
            this.thead.kendoTooltip({
                callout:false,
                position: "top",
                filter: "th",
                content: function (e) {
                    return $(e.target).attr("data-title");
                }
            });
        },
        dataSource  : {
            data: [],
            schema: {
                model: {
                    fields: {
                        cr_no: { type: "number" },
                        shift_no: { type: "number" },
                        bill_no: { type: "number" },
                        cr_date: { type: "date" },
                        device_date: { type: "date" },
                        oper_type: { type: "number" },
                        positions_cnt: { type: "number" },
                        alc_positions_cnt: { type: "number" },
                        non_alc_positions_cnt: { type: "number" },
                        total_sum: { type: "number" },
                        total_discount: { type: "number" },
                        total_extras: { type: "number" },
                        payment_by_cash: { type: "number" },
                        payment_by_card: { type: "number" }
                    }
                }
            }
        }
    }).data("kendoGrid");

    bindWinSet('#checksList', "#checksListGrid", "cookieDiscontinued");

    /*--------------detail Check------------------*/
    function detailInit(e) {
        var detailRow = e.detailRow;
        console.log("start");
        detailRow.find("#posChecksList").kendoGrid({resizable: true,
            sortable: true,
            columnMenu: {
                sortable: false,
                filterable: false,
                messages: {
                    columns: "Колонки"
                }
            },
            columns: [
                { field: "position", title: "Позиция в чеке", width: 120 },
                { field: "operation", title: "Тип", width: 120,
                    template: function(dataItem) {
                        return dataItem.operation != undefined ?
                            getCheckOperationType(dataItem.operation) : "";
                    }},
                { field: "cr_code", title: "Код продукта в кассе", hidden: true, width: 120 },
                { field: "ean", title: "Штрихкод", width: 130 },
                { field: "pdf", title: "Код PDF", width: 130 },
                { field: "prod_name", title: "Наименование продукта в кассе", width: 200, hidden: true },
                { field: "qty", title: 'Количество', width: 120 },
                { field: "price", title: "Цена", format: "{0:c2}", width: 150 },
                { field: "section", title: "Секция", width: 120 },
                { field: "tax", title: "Налог", format: "{0:c}", width: 180, hidden: true }
            ],
            dataSource  : {
                data: [],
                schema: {
                    model: {
                        fields: {
                            position: { type: "number" },
                            operation: { type: "number" },
                            cr_code: { type: "number" },
                            qty: { type: "number" },
                            price: { type: "number" },
                            section: { type: "number" },
                            tax: { type: "number" }
                        }
                    }
                }
            }
        });
        /*var clientDocsRespBillPositions = JSON.parse('{"code":0,"data":[{"cr_code":0,"ean":"1234567890123","id_product":"","operation":0,"pdf":"X123123123123123","position":1,"price":11253,"prod_name":"","qty":1,"section":1,"tax":0},{"cr_code":0,"ean":"1234567890123","id_product":"","operation":0,"pdf":"X123123123123123","position":1,"price":9875,"prod_name":"","qty":1,"section":1,"tax":0},{"cr_code":0,"ean":"1234567890123","id_product":"","operation":0,"pdf":"X123123123123123","position":1,"price":9875,"prod_name":"","qty":1,"section":1,"tax":0},{"cr_code":0,"ean":"1234567890123","id_product":"","operation":0,"pdf":"X123123123123123","position":1,"price":9875,"prod_name":"","qty":1,"section":1,"tax":0}],"message":""}');
        var grid = detailRow.find("#posChecksList").data("kendoGrid");
        grid.dataSource.data( formatDocsRespBillPositions(clientDocsRespBillPositions.data) );*/

        try {
            channel.objects.utm_server.getBillPositions(e.data.id_bill, function (clientDocsRespBillPositions) {
                var grid = detailRow.find("#posChecksList").data("kendoGrid");
                grid.dataSource.data(formatDocsRespBillPositions(clientDocsRespBillPositions.data));
            });
        } catch(e){}
    }

//    kendo.fx($("#checksList")).zoomIn().play();

    reloadCheckList();

    function reloadCheckList(){
        showProcessAlert("Загрузка журнала чеков");

        $("#refreshButton").button('loading');
        clearInterval(timerId);
        timerId = dotted();

        try {
            channel.objects.utm_server.getBills(" ", function (clientDocsRespBills) {
                hideAlerts();

                var grid = $("#checksListGrid").data("kendoGrid");
                grid.dataSource.data(formatDocsRespBills(clientDocsRespBills.data));
                grid.refresh();

                if (grid.dataSource.total() == 0)
                    showInfoAlert("Журнал чеков пуст");
            });
        } catch(e) {
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
        } finally {
            clearInterval(timerId);
            $("#refreshButton").button('reset');
        }
    }

    function formatDocsRespBills(srcData) {
        var result = srcData;
        for (var i = 0; i < result.length; i++) {
            result[i].total_sum = kendo.parseFloat(result[i].total_sum + "%");
            result[i].total_discount = kendo.parseFloat(result[i].total_discount + "%");
            result[i].total_extras = kendo.parseFloat(result[i].total_extras + "%");
            result[i].payment_by_cash = kendo.parseFloat(result[i].payment_by_cash + "%");
            result[i].payment_by_card = kendo.parseFloat(result[i].payment_by_card + "%");
        }
        return result;
    }

    function formatDocsRespBillPositions(srcData) {
        var result = srcData;
        for (var i = 0; i < result.length; i++) {
            result[i].price = kendo.parseFloat(result[i].price + "%");
            result[i].qty = result[i].qty/1000;
        }
        return result;
    }

}