var pointRegistered = false;


var showSettingsView = function() {
    var view = new kendo.View($('#settingsViewTemplate').html());
    layout.showIn("#content", view);
    connectNewVersionSignal();
}

/*------------------Сетевые настройки-----------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
var showSettingsNetwork = function(){
    var view = new kendo.View($('#settingsNetworkTemplate').html());
    layout.showIn("#content", view);

    $("#tabstrip").kendoTabStrip({
        height: 400,
        animation: {
            // fade-in new tab over 500 milliseconds
            open: {
                duration: 100,
                effects: "fadeIn"
            }
        }
    }).data("kendoTabStrip").select(0);


    /*------------------------Ethernet--------------------------*/
    /*                        *****                             */
    /*----------------------------------------------------------*/

    /*----------------Тип адреса (статичсекий/динамичсекмй)------------*/
    $("#dropdownTypeAddress").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "id",
        enable: false,
        change: function(e) {
            var value = this.value();
            if(value == "false"){
                viewModelEthernet.set("isIpDisabled", false);
                viewModelEthernet.set("isGateDisabled", false);
                viewModelEthernet.set("isMaskDisabled", false);
                viewModelEthernet.set("isMacDisabled", false);
                viewModelEthernet.set("isDnsDisabled", false);

                viewModelEthernet.set("isIpInvisible", false);
                viewModelEthernet.set("isGateInvisible", false);
                viewModelEthernet.set("isMaskInvisible", false);
                viewModelEthernet.set("isMacInvisible", false);
                viewModelEthernet.set("isDnsInvisible", false);
            } else {
                viewModelEthernet.set("isIpDisabled", true);
                viewModelEthernet.set("isGateDisabled", true);
                viewModelEthernet.set("isMaskDisabled", true);
                viewModelEthernet.set("isMacDisabled", true);
                viewModelEthernet.set("isDnsDisabled", true);

                viewModelEthernet.set("isIpInvisible", true);
                viewModelEthernet.set("isGateInvisible", true);
                viewModelEthernet.set("isMaskInvisible", true);
                viewModelEthernet.set("isMacInvisible", true);
                viewModelEthernet.set("isDnsInvisible", true);

                validatorEthernet.hideMessages();
            }
        }
    });

    /*----------------------------маска----------------------*/
    $('#inputIp, #inputGateway, #inputMask, #inputMac').inputmask();

    /*----------------------------список интерфейсов----------------------*/
    $("#dropdownInterface").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value",
        optionLabel: "Выберите интерфейс..",
        change: function(e) {
            var value = this.value();
            var dropdownlist = $("#dropdownTypeAddress").data("kendoDropDownList");

            if(!value){
                viewModelEthernet.set("selectedTypeAddress", "");
                dropdownlist.trigger("change");
                dropdownlist.enable(false);

                viewModelEthernet.set("isCheckedInvisible", true);
                viewModelEthernet.set("isSubmitDisabled", true);

                return;
            }
            viewModelEthernet.set("isSubmitDisabled", false);
            ethernetObject.forEach(function(item){
                if (value in item) {
                    dropdownlist.select(function(dataItem) {
                        //alert("dataItem.id = " + dataItem.id);
                        //alert("item[value].interface.dhcp = " + item[value].interface.dhcp);
                        return dataItem.id === String(item[value].interface.dhcp);
                    });
                    dropdownlist.trigger("change");
                    dropdownlist.enable(true);

                    viewModelEthernet.set("ip", item[value].interface.ip);
                    viewModelEthernet.set("gateway", item[value].interface.gateway);
                    viewModelEthernet.set("mac", item[value].interface.mac);
                    viewModelEthernet.set("mask", item[value].interface.mask ? item[value].interface.mask : "255.255.255.0");
                    viewModelEthernet.set("dns", item[value].interface.dns);
                    viewModelEthernet.set("isActive", item[value].isActive);
                    viewModelEthernet.set("isCheckedInvisible", false);

                    return;
                }
            });
        }
    });


    var viewModelCheck = kendo.observable({
        isChecked: true
    });
    kendo.bind($("#check"), viewModelCheck);

    /*------------viewModelEthernet-------------------------------*/
    var viewModelEthernet = kendo.observable({
        /*-------тип адреса---------*/
        selectedTypeAddress: "",
        typesAddress: [
            { id: "false", name: "Статический" },
            { id: "true", name: "Динамический (DHCP)" }
        ],
        /*----------выбор интерфейса-----------*/
        selectedInterface: null,
        interfaces: [],

        checkValue: true,

        isIpDisabled: true,
        isGateDisabled: true,
        isMaskDisabled: true,
        isMacDisabled: true,
        isDnsDisabled: true,
        isSubmitDisabled: true,

        isIpInvisible: true,
        isGateInvisible: true,
        isMaskInvisible: true,
        isMacInvisible: true,
        isDnsInvisible: true,
        isCheckedInvisible: true
    });
    kendo.bind($("#formEthernet"), viewModelEthernet);

    /*-----------валидация формы для Ethernet----------------*/
    var validatorEthernet = $("#formEthernet").kendoValidator({
        //errorTemplate: errorTemplate,
        messages: {
            required: "Поле обязательно для заполнения",
            customIp: "Неверно заполнено поле"
        },
        rules: {
            customIp: function(input) {
                if (input.is("[name=interface.ip], [name=interface.gateway], [name=interface.mask], [name=interface.dns]")) {
                    if(input.val() == '') return true;
                    return input.inputmask("isComplete");
                }
                return true;
            }
        }
    }).data("kendoValidator");

    $("#formEthernet").submit(function(event) {
        event.preventDefault();

        if (validatorEthernet.validate()) {
            $("#formEthernet input").blur();

            var selectedInterface = viewModelEthernet.get("selectedInterface");
            ethernetObject.forEach(function(item){
                if (selectedInterface in item) {
                    $.extend(true, item[selectedInterface], form2js('formEthernet','.',false));
                    //alert( JSON.stringify(jsonObject));
                    try{
                        settingsChannel.objects.cfgsrv.saveNetworkInterfaces(jsonObject);
                        showSuccessMessage("Изменения успешно сохранены.");
                    } catch(e) {
                        showErrorMessage("Ошибка сохранения, попробуйте обновить страницу.");
                    }
                    return;
                }
            });
        } else {
            showWarningMessage("Не корректно заполнены поля формы.");
        }
    });

    /*------------------------Wi-Fi-----------------------------*/
    /*                        *****                             */
    /*----------------------------------------------------------*/

    /*----------------------------Профиль настроек----------------------*/
    $("#dropdownProfile").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value",
        optionLabel: "Профиль настроек..",
        change: function(e) {
            var value = this.value();
            var dropdownlist = $("#dropdownWiFiTypeAddress").data("kendoDropDownList"),
                dropdownlistAccessPoint = $("#dropdownAccessPoint").data("kendoDropDownList");


            if(!value){
                viewModelWiFi.set("selectedTypeAddress", "");
                dropdownlist.trigger("change");
                dropdownlist.enable(false);

                viewModelWiFi.set("selectedAccessPoint", "");
                dropdownlistAccessPoint.enable(false);
                viewModelWiFi.set("isPasswordAccessPointDisabled", true);
                viewModelWiFi.set("passwordAccessPoint", "");
                viewModelWiFi.set("isCheckedInvisible", true);
                viewModelWiFi.set("isSubmitDisabled", true);

                validatorWiFi.hideMessages();

                return;
            }

            viewModelWiFi.set("isSubmitDisabled", false);
            viewModelWiFi.set("isPasswordAccessPointDisabled", false);
            wifiObject.forEach(function(item){
                if (value in item) {
                    dropdownlist.select(function(dataItem) {
                        return dataItem.value === String(item[value].interface.dhcp);
                    });
                    dropdownlist.trigger("change");
                    dropdownlist.enable(true);

                    viewModelWiFi.accessPoints.splice(0,viewModelWiFi.accessPoints.length);
                    item[value].availableSSID.forEach(function(nameItem){
                        viewModelWiFi.accessPoints.push({
                            name: nameItem,
                            value:nameItem
                        });
                    });
                    dropdownlistAccessPoint.select(function(dataItem) {
                        return dataItem.value === item[value].currentSSID;
                    });
                    dropdownlistAccessPoint.enable(true);

                    viewModelWiFi.set("passwordAccessPoint", item[value].currentPassword);
                    viewModelWiFi.set("ip", item[value].interface.ip);
                    viewModelWiFi.set("gateway", item[value].interface.gateway);
                    viewModelWiFi.set("mac", item[value].interface.mac);
                    viewModelWiFi.set("mask", item[value].interface.mask ? item[value].interface.mask : "255.255.255.0");
                    viewModelWiFi.set("dns", item[value].interface.dns);
                    viewModelWiFi.set("isActive", item[value].isActive);
                    viewModelWiFi.set("isCheckedInvisible", false);

                    return;
                }
            });
        }
    });

    /*----------------Имя точки доступа------------*/
    $("#dropdownAccessPoint").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value",
        enable: false
    });

    /*----------------Тип адреса (статичсекий/динамичсекмй)------------*/
    $("#dropdownWiFiTypeAddress").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value",
        enable: false,
        change: function(e) {
            var value = this.value();
            if(value == "false"){
                viewModelWiFi.set("isIpDisabled", false);
                viewModelWiFi.set("isGateDisabled", false);
                viewModelWiFi.set("isMaskDisabled", false);
                viewModelWiFi.set("isMacDisabled", false);
                viewModelWiFi.set("isDnsDisabled", false);

                viewModelWiFi.set("isIpInvisible", false);
                viewModelWiFi.set("isGateInvisible", false);
                viewModelWiFi.set("isMaskInvisible", false);
                viewModelWiFi.set("isMacInvisible", false);
                viewModelWiFi.set("isDnsInvisible", false);
            } else {
                viewModelWiFi.set("isIpDisabled", true);
                viewModelWiFi.set("isGateDisabled", true);
                viewModelWiFi.set("isMaskDisabled", true);
                viewModelWiFi.set("isMacDisabled", true);
                viewModelWiFi.set("isDnsDisabled", true);

                viewModelWiFi.set("isIpInvisible", true);
                viewModelWiFi.set("isGateInvisible", true);
                viewModelWiFi.set("isMaskInvisible", true);
                viewModelWiFi.set("isMacInvisible", true);
                viewModelWiFi.set("isDnsInvisible", true);

                validatorWiFi.hideMessages();
            }
        }
    });

    /*----------------------------маска----------------------*/
    $('#inputWiFiIp, #inputWiFiGateway, #inputWiFiMask, #inputWiFiMac').inputmask();

    /*------------viewModelWiFi-------------------------------*/
    var viewModelWiFi = kendo.observable({
        passwordAccessPoint: "",

        /*----------Выбор профиля-----------*/
        selectedProfile: null,
        profiles: [],

        /*-------------Точка доступа------------------*/
        selectedAccessPoint: null,
        accessPoints: [],

        /*-------тип адреса---------*/
        selectedTypeAddress: "",
        typesAddress: [
            { value: "false", name: "Статический" },
            { value: "true", name: "Динамический (DHCP)" }
        ],
        checkValue: true,

        isAccessPointDisabled: true,
        isPasswordAccessPointDisabled: true,

        isIpDisabled: true,
        isGateDisabled: true,
        isMaskDisabled: true,
        isMacDisabled: true,
        isDnsDisabled: true,
        isSubmitDisabled: true,

        isIpInvisible: true,
        isGateInvisible: true,
        isMaskInvisible: true,
        isMacInvisible: true,
        isDnsInvisible: true,
        isCheckedInvisible: true
    });
    kendo.bind($("#formWiFi"), viewModelWiFi);

    /*-----------валидация формы для WiFi----------------*/
    var validatorWiFi = $("#formWiFi").kendoValidator({
        messages: {
            required: "Поле обязательно для заполнения",
            customIp: "Неверно заполнено поле"
        },
        rules: {
            customIp: function(input) {
                if (input.is("[name=interface.ip], [name=interface.gateway], [name=interface.mask], [name=interface.dns]")) {
                    if(input.val() == '') return true;
                    return input.inputmask("isComplete");
                }
                return true;
            }
        }
    }).data("kendoValidator");

    $("#formWiFi").submit(function(event) {
        event.preventDefault();

        if (validatorWiFi.validate()) {
            $("#formWiFi input").blur();

            var selectedProfile = viewModelWiFi.get("selectedProfile");
            wifiObject.forEach(function(item){
                if (selectedProfile in item) {
                    $.extend(true, item[selectedProfile], form2js('formWiFi','.',false));
                    try{
                        settingsChannel.objects.cfgsrv.saveNetworkInterfaces(jsonObject);
                        showSuccessMessage("Изменения успешно сохранены.");
                    } catch(e) {
                        showErrorMessage("Ошибка сохранения, попробуйте обновить страницу.");
                    }
                    return;
                }
            });
        } else {
            showWarningMessage("Не корректно заполнены поля формы.");
        }
    });




    /*------------------------ Modem ---------------------------*/
    /*                        *****                             */
    /*----------------------------------------------------------*/

    /*------------viewModelModem-------------------------------*/
    $('#inputProvider').inputmask("Regex");

    var viewModelModem = kendo.observable({
        isSubmitDisabled: true
    });
    kendo.bind($("#formModems"), viewModelModem);

    $("#formModems").submit(function(event) {
        event.preventDefault();
        $.extend(true, modemsObject[0], form2js('formModems','.',false));
        try{
            settingsChannel.objects.cfgsrv.saveNetworkInterfaces(jsonObject);
            showSuccessMessage("Изменения успешно сохранены.");
        } catch(e) {
            showErrorMessage("Ошибка сохранения, попробуйте обновить страницу.");
        }
    });


    /*------------------------Proxy-----------------------------*/
    /*                        *****                             */
    /*----------------------------------------------------------*/

    /*----------------------------Профиль настроек----------------------*/
    $("#dropdownAvailableTypes").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });

    /*------------viewModelProxy -------------------------------*/
    var viewModelProxy = kendo.observable({
        /*----------AvailableTypes-----------*/
        selectedType: null,
        availableTypes: [],
        isSubmitDisabled: true
    });
    kendo.bind($("#formProxy"), viewModelProxy);

    /*-----------валидация формы для Proxy----------------*/
    var validatorProxy = $("#formProxy").kendoValidator({
        messages: {
            required: "Поле обязательно для заполнения"
        }
    }).data("kendoValidator");


    $("#formProxy").submit(function(event) {
        event.preventDefault();
        if (validatorProxy.validate()) {
            $.extend(true, proxyObject, form2js('formProxy','.',false));
            try{
                settingsChannel.objects.cfgsrv.saveProxySettings(proxyObject);
                showSuccessMessage("Изменения успешно сохранены.");
            } catch(e) {
                showErrorMessage("Ошибка сохранения, попробуйте обновить страницу.");
            }
        } else {
            showWarningMessage("Не заполнены обязательные поля.");
        }
    });



//    /*---------------- Тест связи и Интернет -------------------*/
//    /*                        *****                             */
//    /*----------------------------------------------------------*/
//
//    /*------------viewModelCheckConnection-------------------------------*/
//    var viewModelCheckConnection = kendo.observable({
//        address: "google.com",
//        checkConnection: function(){
//            if (validatableCheckConnection.validate()){
//                var address = this.get("address");
//                if(true){
//                    showMessage("Соединение с Интернет успешно установлено.");
//                } else {
//                    showMessage("Соединение с Интернет не установлено.<br>" +
//                        "Проверте правильность введенного адреса страницы.");
//                }
//            }
//        }
//    });
//    kendo.bind($("#formCheckConnection"), viewModelCheckConnection);
//
//    /*-----------валидация формы Тест связи с Интернет----------------*/
//    var validatableCheckConnection = $("#formCheckConnection").kendoValidator({
//        messages: {
//            required: "Поле обязательно для заполнения"
//        }
//    }).data("kendoValidator");




    /*---------------- Прием данных через соккеты -------------------*/
    /*                        *****                             */
    /*----------------------------------------------------------*/

    /*---------------------------WI-FI, Ethernet, USB-Modem----------------------------------*/
    var ethernetObject, wifiObject, modemsObject, proxyObject, jsonObject;

    showProcessAlert("Загрузка данных..","Ethernet");
    showProcessAlert("Загрузка данных..","WiFi");
    showProcessAlert("Загрузка данных..","Modems");

    try{
        settingsChannel.objects.cfgsrv.getNetworkInterfaces( function(niObject) {
            hideAlerts("Ethernet");
            hideAlerts("WiFi");
            hideAlerts("Modems");

            jsonObject = niObject;
//            console.log(JSON.stringify(jsonObject));

            if ("ethernet" in niObject){
                ethernetObject  = niObject.ethernet;
                ethernetObject.forEach(function(itemInterface){
                    for(var name in itemInterface){
                        viewModelEthernet.interfaces.push({
                            name: name,
                            value:name
                        });
                    }
                });

                var dropdownInterface = $("#dropdownInterface").data("kendoDropDownList");
                viewModelEthernet.set("selectedInterface", viewModelEthernet.get("interfaces")[0]);
                dropdownInterface.trigger("change");
            }
            if ("wifi" in niObject) {
                wifiObject = niObject.wifi;
                wifiObject.forEach(function(itemProfile){
                    for(var name in itemProfile){
                        viewModelWiFi.profiles.push({
                            name: name,
                            value:name
                        });
                    }
                });

                var dropdownProfile = $("#dropdownProfile").data("kendoDropDownList");
                viewModelWiFi.set("selectedProfile", viewModelWiFi.get("profiles")[0]);
                dropdownProfile.trigger("change");
            }
            if ("modems" in niObject) {
                modemsObject = niObject.modems;

                viewModelModem.set("apn", modemsObject[0].apn);
                viewModelModem.set("pin", modemsObject[0].pin);
                viewModelModem.set("provider", modemsObject[0].provider);
                viewModelModem.set("phone", modemsObject[0].phone);
                viewModelModem.set("portName", modemsObject[0].portName);
                viewModelModem.set("userName", modemsObject[0].userName);
                viewModelModem.set("password", modemsObject[0].password);

                viewModelModem.set("isSubmitDisabled", false);
            }
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "Ethernet");
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "WiFi");
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "Modems");
        }, 500);
    }

    /*-----------------------------------PROXY--------------------------*/

    showProcessAlert("Загрузка данных..","Proxy");

    try{
        settingsChannel.objects.cfgsrv.getProxySettings( function(niObject) {
            hideAlerts("Proxy");
            viewModelProxy.set("isSubmitDisabled", false);

            proxyObject = niObject;
//            alert(JSON.stringify(proxyObject));
            proxyObject.availableTypes.forEach(function(dataItem){
                viewModelProxy.availableTypes.push({
                    name: dataItem,
                    value:dataItem
                });
            });
            viewModelProxy.set("selectedType", proxyObject.type);
            viewModelProxy.set("host", proxyObject.host);
            viewModelProxy.set("port", proxyObject.port);
            viewModelProxy.set("user", proxyObject.user);
            viewModelProxy.set("password", proxyObject.password);
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "Proxy");
        }, 500);
    }
}


/*------------------Настройки УТМ----------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
var showSettingsUtm = function(){
    var view = new kendo.View($('#settingsUtmTemplate').html());
    layout.showIn("#content", view);

    /*------------viewModelCheckConnectionUtm---------------------*/
    var viewModelUtm = kendo.observable({
        isSubmitDisabled: true,
        saveUtmConfig: function(event) {
            event.preventDefault();

            if (validatorUtm.validate()) {
                $.extend(true, utmObject, form2js('formUtm', '.', false));

                try {
                    settingsChannel.objects.cfgsrv.saveUtmConfig(utmObject);
                    showSuccessMessage("Изменения успешно сохранены.");
                } catch (e) {
                    showErrorMessage("Ошибка сохранения, попробуйте обновить страницу.");
                }
            } else {
                showWarningMessage("Не заполнены обязательные поля.");
            }
        }
    });
    kendo.bind($("#formUtm"), viewModelUtm);

    /*-----------валидация формы Тест связи с УТМ----------------*/
    var validatorUtm = $("#formUtm").kendoValidator({
        messages: {
            required: "Поле обязательно для заполнения"
        }
    }).data("kendoValidator");


    var utmObject;
    showProcessAlert("Загрузка данных");
    clearInterval(timerId);
    timerId = dotted();
    try{
        settingsChannel.objects.cfgsrv.getUtmConfig( function(niObject) {
            hideAlerts();
            utmObject = niObject;

            viewModelUtm.set("gostPin", utmObject.gostPin);
            viewModelUtm.set("pkiPin", utmObject.pkiPin);

            viewModelUtm.set("isSubmitDisabled", false);
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
        }, 500);
    } finally {
        clearInterval(timerId);
    }
}



/*------------------Настройки Кассы----------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
var showSettingsCash = function(){
    var view = new kendo.View($('#settingsCashTemplate').html());
    layout.showIn("#content", view);

    $("#dropdownAvailableDataBits").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });
    $("#dropdownAvailableFlowControle").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });
    $("#dropdownAvailableParity").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });
    $("#dropdownAvailablePorts").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });

    /*------------viewModelCashPort -------------------------------*/
    var viewModelCashPort = kendo.observable({
        dataBits: null,
        availableDataBits: [],

        flowControl: null,
        availableFlowControle: [],

        parity: null,
        availableParity: [],

        port: null,
        availablePorts: [],

        checkValue: true,

        isSubmitDisabled: true
    });

    kendo.bind($("#formCashPort"), viewModelCashPort);

    $("#formCashPort").submit(function(event) {
        event.preventDefault();

        $.extend(true, cashPortObject, form2js('formCashPort','.',false));
        try{
            settingsChannel.objects.cfgsrv.saveCashPort(cashPortObject);
            showSuccessMessage("Изменения успешно сохранены.");
        } catch(e) {
            showErrorMessage("Ошибка сохранения, попробуйте обновить страницу.");
        }

    });

    var cashPortObject;
    showProcessAlert("Загрузка данных");
    clearInterval(timerId);
    timerId = dotted();
    try{
        settingsChannel.objects.cfgsrv.getCashPort( function(niObject) {
            cashPortObject = niObject;
            hideAlerts();
            viewModelCashPort.set("isSubmitDisabled", false);
//            console.log(JSON.stringify(cashPortObject));

            if("availableDataBits" in cashPortObject) {
                cashPortObject["availableDataBits"].forEach(function (data) {
                    viewModelCashPort["availableDataBits"].push({
                        name: data,
                        value: data
                    });
                });
            }
            if("availableFlowControle" in cashPortObject) {
                cashPortObject["availableFlowControle"].forEach(function (data) {
                    viewModelCashPort["availableFlowControle"].push({
                        name: data,
                        value: data
                    });
                });
            }
            if("availableParity" in cashPortObject) {
                cashPortObject["availableParity"].forEach(function (data) {
                    viewModelCashPort["availableParity"].push({
                        name: data,
                        value: data
                    });
                });
            }
            if("availablePorts" in cashPortObject) {
                cashPortObject["availablePorts"].forEach(function (data) {
                    viewModelCashPort["availablePorts"].push({
                        name: data,
                        value: data
                    });
                });
            }

            viewModelCashPort.set("dataBits", cashPortObject.dataBits ? cashPortObject.dataBits : "8");
            viewModelCashPort.set("flowControl", cashPortObject.flowControl);
            viewModelCashPort.set("parity", cashPortObject.parity);
            viewModelCashPort.set("port", cashPortObject.port);
            viewModelCashPort.set("baudrate", cashPortObject.baudrate);
            viewModelCashPort.set("isActive", cashPortObject.autosearch);
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
        }, 500);
    } finally {
        clearInterval(timerId);
    }
}


/*------------------Смена часового пояса----------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/

var showChangeTimeZone = function () {

    //getStatusData()
    var FORM_ID = "#formTimeZone";
    var LIST_ELEMENT_ID = "#changeTimeZone";
    var dataTimeZones = [];
    var view = new kendo.View($('#settingsTimeZone').html());
    layout.showIn("#content", view);
    var $sendButton = $(FORM_ID + " button[type='submit']").kendoButton({
        enable: false
    }).data("kendoButton");

    // Формат часового пояса для вывода в шаблон
    function formatGMT(int) {
        return ( int > 0)? "GMT +" + i : "GMT " + i;
    }
    // Созданием массив с часовыми поясами
    for (var i = -12; i <= 12; i++) {
        dataTimeZones.push({
            title: formatGMT(i),
            value: -i,
        })
    };

    $(LIST_ELEMENT_ID).kendoDropDownList({
        dataTextField: "title",
        dataValueField: "value",
        dataSource: dataTimeZones,
        autoBind: false,
        text: 'Ждем данных с сервера',
        change: function() {
            $sendButton.enable(true);
        }
    });
    $sendButton.bind('click', function (e) {
        e.preventDefault();
        changeTimeZone();
    })
    //Пинаем веб-сокет для получения данных по времени
    window.settingsChannel.objects.cfgsrv.getStatusData();
    //Вытягиваем данные с веб-сокета
    var mess = function (message) {
        //Получаем значение для валидации
        var timeZone = parseInt(JSON.parse(message.data).data.dtOffcet) || false;
        if (!Number.isInteger(timeZone)) {
            showErrorMessage("Ошибка получения часового пояса - некорректные данные");
            return false;
        }

        if (-12 <= timeZone <= 12) {
            var timezoneList = $(LIST_ELEMENT_ID).data("kendoDropDownList");
            timezoneList.value(timeZone);
            // После получения часового пояса удаляем обработчик веб-сокета
            this.removeEventListener('message', mess);
        };
    };

    var socketMsg = settingsChannel.transport.addEventListener('message', mess);

    // Попап перед вызовом функции смены часового пояса
    var changeTimeZone = function () {
        confirmMessageDialog.open().center();

        var viewModelConfirmDialog = kendo.observable({
            message: "Для смены часового пояса SmartBox будет перезагружен",
            cancel: function() {
                confirmMessageDialog.close();
            },
            continue: function() {
                try {
                    var timeZone = parseInt($(LIST_ELEMENT_ID).data("kendoDropDownList").value());
                    if (!Number.isInteger(timeZone)) {
                        console.log(typeof timeZone, timeZone);
                        showErrorMessage("Ошибка получения часового пояса из списка - некорректные данные");
                        return false;
                    }
                    settingsChannel.objects.cfgsrv.changeTimeZone({'offcet': timeZone});
                } catch (e) {
                    console.log(e);
                    showErrorMessage("Произошла ошибка, попробуйте обновить страницу.");
                }
                confirmMessageDialog.close();
            }
        });
        kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);
    }
}

/*------------------Системные логи----------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
var showSystemLogs = function(){
    var view = new kendo.View($('#systemLogsTemplate').html());
    layout.showIn("#content", view);

    $("#tabstripLog").kendoTabStrip({
        height: 400,
        animation: {
            // fade-in new tab over 500 milliseconds
            open: {
                duration: 100,
                effects: "fadeIn"
            }
        }
    }).data("kendoTabStrip").select(0);

    var viewModel = kendo.observable({
        systemLog: "",
        utmLog: "",
        egaisLog: "",
        cRowsSysLog: 1,
        cRowsUtmLog: 1,
        cRowsEgaisLog: 1,
        refreshSystemLog: function(){
            refreshSystemLog(this);
        },
        refreshUtmLog: function(){
            refreshUtmLog(this);
        },
        refreshEgaisLog: function(){
            refreshEgaisLog(this);
        }
    });
    kendo.bind($("#tabstripLog"), viewModel);

    refreshSystemLog(viewModel);
    refreshUtmLog(viewModel);
    refreshEgaisLog(viewModel);
}

/*------------------------Обновление логов------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
function refreshSystemLog(viewModel){
    showProcessAlert("Загрузка системных логов..","SystemLog");

    try{
        settingsChannel.objects.cfgsrv.getSystemLog( function(niObject) {
            viewModel.set("cRowsSysLog", 30);
            viewModel.set("systemLog", niObject);
            hideAlerts("SystemLog");
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "SystemLog");
        }, 500);
    }
}

function refreshUtmLog(viewModel){
    showProcessAlert("Загрузка логов УТМ..","UtmLog");

    try{
        settingsChannel.objects.cfgsrv.getUtmLog( function(niObject) {
            viewModel.set("cRowsUtmLog", 30);
            viewModel.set("utmLog", niObject);
            hideAlerts("UtmLog");
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "UtmLog");
        }, 500);
    }
}

function refreshEgaisLog(viewModel){
    showProcessAlert("Загрузка логов кассового приложения..","EgaisLog");

    try{
        settingsChannel.objects.cfgsrv.getEgaisLog( function(niObject) {
            viewModel.set("cRowsEgaisLog", 30);
            viewModel.set("egaisLog", niObject);
            hideAlerts("EgaisLog");
        });
    } catch(e){
        setTimeout( function(){
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>", "EgaisLog");
        }, 500);
    }
}

/*-------------------------Регистрация----------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
var showCheckIn = function(){
    var view = new kendo.View($('#checkInTemplate').html());
    layout.showIn("#content", view);

    //    channel.objects.utm_server.authDone(function(regResult){
//        alert(regResult ? "Регистрация выполнена":"Внимание! Не удалось выполнить регистрацию");
//    });
    try {
        channel.objects.utm_server.authDone.connect(function (success) {
            if (success) {
                showInfoAlert("Регистрация точки выполнена");
            }
            else {
                showErrorAlert("Не удалось выполнить регистрацию точки");
            }
            pointCheckAuth();
        });
    } catch(e){}

    var btnRegDoRegistration = $("#btnRegDoRegistration").kendoButton();
    //var regCode = document.getElementById("inputRegCode").value;
    //alert(document.getElementById("inputRegCode").innerHTML);
    //document.getElementById("inputRegCode").value = new Date();

    $("#btnRegDoRegistration").kendoButton({
        icon : "tick",
        click: function(e) {

            if (!pointRegistered || confirm("Внимание! Данная точка уже зарегистрирована, вы действительно хотите выполнить перерегистрацию?")){
                if (document.getElementById("inputRegCode").value){
                    showProcessAlert("Выполняется регистрация точки, пожалуйста подождите...")
                    try {
                        channel.objects.utm_server.registrate(document.getElementById("inputRegCode").value,
                            function (regResult) {
                                hideAlerts();
                                pointCheckAuth();
                                showSuccessMessage("Регистрация успешно завершена.");
                            });
                    } catch(e){
                        hideAlerts();
                        showErrorMessage("Во время регистрации произошла ошибка, попробуйте обновить страницу.");
                    }
                }
                else{
                    showWarningMessage("Необходимо ввести одноразовый код регистрации.");
                }
            }


            btnRegDoRegistration.enable(true);

        }
    });

    pointCheckAuth();

    if (currentAuth.registered){

    }
    else{

    }
}

/*--------------Шаблон ошибок------------------*/
var errorTemplate = '<div class="k-widget k-tooltip k-tooltip-validation" style="margin:0.5em">' +
    '<span class="k-icon k-warning"> </span>' +
    '#=message#<div class="k-callout k-callout-n"></div></div>';



/*---------------------------pointCheckAuth---------------------------*/
var pointCheckAuth = function(){
    try {
        channel.objects.utm_server.checkAuth(function (authResultResp) {
            var currentAuth = authResultResp.data;
            pointRegistered = currentAuth.registered;

            document.getElementById("inputRegFsrar").value = currentAuth.fsrar_id ? currentAuth.fsrar_id : "нет данных";
            document.getElementById("inputRegInn").value = currentAuth.inn ? currentAuth.inn : "нет данных";
            document.getElementById("inputRegKpp").value = currentAuth.kpp ? currentAuth.kpp : "нет данных";
            ;
            document.getElementById("inputRegCode").value = "";
            document.getElementById("regStatusLabel").innerHTML = currentAuth.registered ? "Точка зарегистрирована" :
                "Внимание! Данная точка не зарегистрирована";

            document.getElementById("btnRegDoRegistration").innerHTML = currentAuth.registered ?
                "Выполнить перерегистрацию точки" :
                "Выполнить регистрацию";
            //Почему то после установки текста слетает иконка кендовская
            $("#btnRegDoRegistration").kendoButton({
                icon: "tick"
            });

            //отображение статуса регистрации
            if (!OPEN_WINDOW_HEART_BEAT) {
                windowHeartBeat.open();
                $('#showParamUtm').show();
                OPEN_WINDOW_HEART_BEAT = true;
            } else {
                windowHeartBeat.refresh();
            }
            $('#registeredTerminalInfo').show();
            var terminalId = currentAuth.terminal_id ? currentAuth.terminal_id : "";
            var registeredTerminalInfo = currentAuth.registered ? "<strong>SmartBox зарегистрирован:</strong> id=" + terminalId :
                "<strong><span style='color: red;'>SmartBox не зарегистрирован</span></strong>";
            $("#registeredTerminalInfo").html(registeredTerminalInfo);

//        currentAuth = authResult;
        });
    } catch(e){}
}

/*---------------------------registeredTerminalInfo---------------------------*/
var registeredTerminalInfo = function(){
    try {
        channel.objects.utm_server.checkAuth(function (authResultResp) {
        var currentAuth = authResultResp.data;

            if (!OPEN_WINDOW_HEART_BEAT) {
                windowHeartBeat.open();
                $('#showParamUtm').show();
                OPEN_WINDOW_HEART_BEAT = true;
            } else {
                windowHeartBeat.refresh();
            }
            $('#registeredTerminalInfo').show();
            var terminalId = currentAuth.terminal_id ? currentAuth.terminal_id : "";
            var registeredTerminalInfo = currentAuth.registered ? "<strong>SmartBox зарегистрирован:</strong> id=" + terminalId :
                "<strong><span style='color: red;'>SmartBox не зарегистрирован</span></strong>";
            $("#registeredTerminalInfo").html(registeredTerminalInfo);
        });
    } catch(e){}
}

/*------------------------Темы------------------------------*/
/*                        *****                             */
/*----------------------------------------------------------*/
var showSkin = function(){
    var view = new kendo.View($('#skinTemplate').html());
    layout.showIn("#content", view);

    var theme = "flat",
        cookieTheme = $.cookie('cookietheme');
    if(cookieTheme){
        theme = cookieTheme;
    }
    $("#theme").kendoDropDownList({
        dataTextField: "text",
        dataValueField: "value",
        value: theme,
        dataSource: [
            { text: "Default", value: "default" },
            { text: "Blue Opal", value: "blueopal" },
            { text: "Bootstrap", value: "bootstrap" },
            { text: "Silver", value: "silver" },
            { text: "Uniform", value: "uniform" },
            { text: "Metro", value: "metro" },
            { text: "Black", value: "black" },
            { text: "Metro Black", value: "metroblack" },
            { text: "High Contrast", value: "highcontrast" },
            { text: "Moonlight", value: "moonlight" },
            { text: "Flat", value: "flat" }
        ],
        change: function(e) {
            theme = this.value();
            window.kendoThemeChooser.changeTheme(theme, true);
            $.cookie('cookietheme', theme, { expires: 30, path: '/' });
            //initCharts(theme);
        }
    });

    $("#dimensions").kendoDropDownList({
        dataTextField: "text",
        dataValueField: "value",
        value: "common-bootstrap",
        dataSource: [
            { text: "Default", value: "common" },
            { text: "Bootstrap", value: "common-bootstrap" }
        ],
        change: function(e) {
            window.kendoThemeChooser.changeCommon(this.value(), true);
        }
    });

    function changeFontSize(e) {
        var value = $("#font-size").kendoDropDownList("value");

        $("body").css("font-size", value + "px");
    }

    $("#font-size").kendoDropDownList({
        dataTextField: "text",
        dataValueField: "value",
        value: 14,
        height: 204,
        dataSource: [
            { text: "10px", value: 10 },
            { text: "12px", value: 12 },
            { text: "14px", value: 14 },
            { text: "16px", value: 16 },
            { text: "18px", value: 18 },
            { text: "20px", value: 20 }
        ],
        change: changeFontSize
    });
}