var dialogEnterStamps;

$(window).load(function() {
    dialogEnterStamps = $("#dialogEnterStamps").kendoWindow({
        animation: false,
        title: "Диалог",
        visible: false,
        scrollable: false,
        resizable: false,
        modal: true,
        pinned: true,
        width: 500
    }).data("kendoWindow");

    $('#dialogEnterStamps').keydown(function(eventObject){
        if(eventObject.which == '27')
            dialogEnterStamps.close();
    });

    $(window).resize(function(){
        var width;

        if (window.innerWidth < '768') {
            width = 300;
        } else {
            width = 500;
        }

        dialogEnterStamps.setOptions({
            width: width
        });
        dialogEnterStamps.center();
    });
    $(window).resize();
});

var showEnterStompsDialogView = function() {
    var selectedItem;
    dialogEnterStamps.content( kendo.template($("#wrapDialogEnterStamps").html()) );
    dialogEnterStamps.center().open();

    var viewModelDialogInfoFormA = kendo.observable({
        titleEnterField: "Сканируйте или вводите с клавиатуры федеральные марки:",
        cancel: function() {
            dialogEnterStamps.close();
        }
    });
    kendo.bind($("#dialogEnterStamps"), viewModelDialogInfoFormA);

    $("#inpStamps").focus();

    $("#enterStamps").kendoButton({
        icon: "arrowhead-e"
    });

    $("#formStamps").on('submit', function(){
        var val = $("#inpStamps").val();

        var data = DATA_SOURCE_STAMPS_LIST.data();
        var stampsLength = data.length;
        if(stampsLength >= SELECT_POS.quantity) {
            alert("Количество федеральных марок превышает количество товара в позиции.");
            return false;
        }

        var flagIdentity = data.every(function(obj) {
            return obj.name != val;
        });

        if(!flagIdentity) {
            alert("Федеральная марка должна быть уникальной.");
            return false;
        }

        DATA_SOURCE_STAMPS_LIST.insert(0, { name: val });

        $("#inpStamps").val("").focus();
        return false;
    });
}