var dialogInfoFormA;

$(window).load(function() {
    dialogInfoFormA = $("#dialogInfoFormA").kendoWindow({
        animation: false,
        actions: [ "Maximize", "Close" ],
        title: "Информация из справки А",
        visible: false,
        scrollable: false,
        resizable: false,
        modal: true,
        pinned: true,
        width: 500
    }).data("kendoWindow");

    $('#dialogInfoFormA').keydown(function(eventObject){
        if(eventObject.which == '27')
            dialogInfoFormA.close();
    });

    $(window).resize(function(){
        var width;

        if (window.innerWidth < '768') {
            width = 280;
        } else {
            width = 500;
        }

        dialogInfoFormA.setOptions({
            width: width
        });
        dialogInfoFormA.center();
    });
    $(window).resize();
});

var showInfoFormADialogView = function(dataItem, editFlag) {
    var selectedItem;
    dialogInfoFormA.content( kendo.template($("#wrapDialogInfoFormA").html()) );
    dialogInfoFormA.center().open();

    var viewModelDialogInfoFormA = kendo.observable({
        cancel: function() {
            dialogInfoFormA.close();
        },
        save: function() {
            if(validatable.validateInput($("input[name=qtyFormA]")) &
                validatable.validateInput($("input[name=dateBottling]")) &
                validatable.validateInput($("input[name=docNum]")) &
                validatable.validateInput($("input[name=dateDoc]"))) {
                if (!editFlag) {
                    DATA_SOURCE_POS_LIST.insert(0, dataItem);
                    $("#positionsListGrid").data("kendoGrid").select("tr:eq(0)");

                    DATA_SOURCE_STAMPS_LIST.data([]);
                }
                INFO_FORM_A[dataItem.id_product] = getValueFormA();

                var grid = $("#productsListGrid").data("kendoGrid");
                grid.select(grid.select());

                dialogInfoFormA.close();
            }
        }
    });
    kendo.bind($("#dialogInfoFormA"), viewModelDialogInfoFormA);

    $("#inpQtyFormA").kendoNumericTextBox({
        format: "n0",
        decimals: 0,
        min: 0,
        value: 0
    });

    var defaultDate = new Date();
    defaultDate = new Date(defaultDate.getFullYear(), defaultDate.getMonth(), defaultDate.getDate());

    $("#inpDateBottling").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#inpDateBottling").attr("readonly", "readonly");

    $("#inpDateDoc").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#inpDateDoc").attr("readonly", "readonly");

    $("#inpDateEgais").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });

    if(editFlag) refreshFormA(dataItem.id_product);

    var validatable = $("#infoFormA").kendoValidator({
        validateOnBlur: false,
        messages: {
            required: function(input){
                return input.data("message");
            }
        }
    }).data("kendoValidator");
}

function refreshFormA(index){
    var obj = INFO_FORM_A[index];
    var formABottlingDateValue = Date.parse(obj.bottlingDate),
        formATtnDateValue = Date.parse(obj.ttnDate),
        formAEgaisFixDateValue = Date.parse(obj.egaisFixDate);

    $("#inpQtyFormA").data("kendoNumericTextBox").value(obj.qty);
    $("#inpDateBottling").data("kendoDatePicker").value( !isNaN(formABottlingDateValue) ? new Date(formABottlingDateValue) : "" );
    $("#inpDocNum").val(obj.ttnNumber);
    $("#inpDateDoc").data("kendoDatePicker").value( !isNaN(formATtnDateValue) ? new Date(formATtnDateValue) : "" );
    $("#inpEgaisNum").val(obj.egaisFixNumber);
    $("#inpDateEgais").data("kendoDatePicker").value( !isNaN(formAEgaisFixDateValue) ? new Date(formAEgaisFixDateValue) : "" );

    return obj;
}

function getValueFormA(){
    var obj = {};
    var formABottlingDateValue = $("#inpDateBottling").data("kendoDatePicker").value(),
        formATtnDateValue = $("#inpDateDoc").data("kendoDatePicker").value(),
        formAEgaisFixDateValue = $("#inpDateEgais").data("kendoDatePicker").value();

    obj.qty = $("#inpQtyFormA").data("kendoNumericTextBox").value();
    obj.bottlingDate = formABottlingDateValue ? new Date(formABottlingDateValue).toISOString() : "";
    obj.ttnNumber = $("#inpDocNum").val();
    obj.ttnDate = formATtnDateValue ? new Date(formATtnDateValue).toISOString() : "";
    obj.egaisFixNumber = $("#inpEgaisNum").val();
    obj.egaisFixDate = formAEgaisFixDateValue ? new Date(formAEgaisFixDateValue).toISOString() : "";

    return obj;
}