var dialogPersons;
var gridPersonsList;

$(window).load(function() {
    dialogPersons = $("#dialogPersons").kendoWindow({
        animation: false,
        actions: [ "Maximize", "Close" ],
        title: "Выбор контрагента",
        visible: false,
        scrollable: false,
        modal: true,
        pinned: true,
        width: "95%",
        height: 480,
        resize: function() {
            var o = this;
            var temp = $("#inpSearchPersons").val();
            gridPersonsList.setOptions({
                height: $("#dialogPersons").outerHeight() - 70
            });

            $("#inpSearchPersons").on('keyup', function () {
                filterAllGrid(this, "gridPersonsList");
            });
            $("#inpSearchPersons").val(temp);

            $("#gridPersonsList").kendoTooltip({
                filter: "td.table-cell:not(:empty)",
                position: "right",
                animation: {
                    open: {
                        effects: "fade:in",
                        duration: 200
                    }
                },
                showAfter: 400,
                content: function (e) {
                    var target = e.target;
                    var content = target.text();
                    return content;
                }
            }).data("kendoTooltip");
        }
    }).data("kendoWindow");
});

var showPersonsDialogView = function(field) {
    var selectedItem;
    dialogPersons.content( kendo.template($("#contentDialogPersonsTemplate").html()) );
    dialogPersons.center().open();

    var viewModelDialogPersons = kendo.observable({
        cancel: function() {
            dialogPersons.close();
        },
        choose: function() {
            $("#" + field).val(selectedItem.name + ", " + selectedItem.address).data("id", selectedItem.id);
            dialogPersons.close();
        },
        isDisabledChoose: true
    });
    kendo.bind($("#dialogPersons"), viewModelDialogPersons);

//    var jsondata = [];
//    for (var i = 0; i < 20; i++)
//        jsondata.push({
//            id: i+1,
//            client_reg_id: "2342343242000001110010",
//            name: (i % 2 == 0) ? 'ООО "Прохлада"' : "Винтер",
//            inn: "475893459834",
//            kpp: "888490348034",
//            address: (i % 4 == 0) ? "Россия, 85503, Курская область, г. Курск, ул. Гайдара, 18" :
//                (i % 4 == 1) ? "Россия, 85503, Курская область, г. Курск, ул. Ленина, 18" :
//                    (i % 4 == 2) ? "Россия, 85503, Курская область, г. Курск, ул. Радищева, 18" :
//                        "Россия, 85503, Курская область, г. Курск, ул. Московская, 18"
//        });

    gridPersonsList = $("#gridPersonsList").kendoGrid({
        dataSource: {
            data: [],
            schema: {
                model: {
                    fields: {
                        id: { type: "number" }
                    }
                }
            }
        },
        filterable: {
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:"
            },
            operators: {
                string: {
                    eq: "Равно",
                    neq: "Не равно",
                    contains: "Содержит",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                }
            },
            extra: false
        },
        groupable: false,
        resizable: true,
        reorderable: false,
        sortable: true,
        selectable: "row",
        height: $("#dialogPersons").outerHeight() - 70,
        toolbar: [
            { template: kendo.template($("#toolbarPersonsListGrid").html()) }
        ],
        columns: [
            { field: "id", title: "ID", width: 50, filterable: false, hidden: true },
            { field: "pos", headerTemplate: "",
                template: function(dataItem){
                    var ds = $("#gridPersonsList").data("kendoGrid").dataSource,
                    index = ds.indexOf( dataItem );
                    return index + 1;
                },
                width: 40, filterable: false
            },
            { field: "clientRegId", title: "ФСРАР ID", attributes: { "class": "table-cell" }, width: 160, filterable: true,
                template: function (dataItem) {
                    return dataItem.client_reg_id;
                }
            },
            { field: "name", title: "Контрагент", attributes: { "class": "table-cell" }, width: 230, filterable: true },
            { field: "inn", title: "ИНН", width: 120, filterable: true },
            { field: "kpp", title: "КПП", width: 120, filterable: true },
            { field: "address", title: "Адрес", attributes: { "class": "table-cell" }, width: 250, filterable: true }
        ],
        change: function(){
            selectedItem = this.dataItem(this.select());
            viewModelDialogPersons.set("isDisabledChoose", false);
        },
        dataBound: function(e) {
            viewModelDialogPersons.set("isDisabledChoose", true);
        }
    }).data("kendoGrid");

    $("#gridPersonsList").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function (e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $("#inpSearchPersons").on('keyup', function () {
        filterAllGrid(this, "gridPersonsList");
    });

    gridPersonsList.dataSource.data(DATA_PERSONS);
    gridPersonsList.refresh();

//    reloadPersonsList();
//
//    function reloadPersonsList(){
//        kendo.ui.progress($("#gridPersonsList"), true);
//
//        try {
//            channel.objects.utm_server.getPersons(function (response) {
//                kendo.ui.progress($("#gridPersonsList"), false);
//
//                var grid = $("#gridPersonsList").data("kendoGrid");
//                grid.dataSource.data(response.data);
//                grid.refresh();
//            });
//        } catch(e) {
//            kendo.ui.progress($("#gridPersonsList"), false);
//        }
//    }
}