var viewModelWaybill,
    validatableFormWaybill,
    objWaybill,
    objCreateWaybill;

var editFlag;

var showWaybillCreateFormView = function(editDoc) {
    var view = new kendo.View($('#WaybillCreateFormViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    objWaybill = {};
    objCreateWaybill = {};
    DATA_PERSONS = [];

    editFlag = editDoc ? true : false;

    viewModel.docFormTitle = !editFlag ? "Создание накладной" :
        editDoc.operation_type == 1 ? "Редактирование накладной" :
            editDoc.operation_type == 2 ? "Возврат накладной" : "";
    viewModel.docFormNumber = (editFlag && editDoc.doc_num) ? " № " + editDoc.doc_num : "";
    viewModel.docId = editFlag ? editDoc.doc_id : null;
    viewModel.operationType = editFlag ? editDoc.operation_type : null;
    kendo.bind($("span"), viewModel);

    $("#dropdownDocType").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });

    var defaultDate = new Date();
    defaultDate = new Date(defaultDate.getFullYear(), defaultDate.getMonth(), defaultDate.getDate());

    $("#inpDate").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#inpDate").attr("readonly", "readonly");

    $("#inpShipDate").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#inpShipDate").attr("readonly", "readonly");

    $("#buttonConsignee").kendoButton({
        icon: "search",
        click: function(){
            showPersonsDialogView("inpIdConsignee");
        }
    });
    $("#buttonSupplier").kendoButton({
        icon: "search",
        click: function(){
            showPersonsDialogView("inpIdSupplier");
        }
    });
    $("#buttonClearSupplier").kendoButton({
        icon: "arrowhead-w",
        click: function() {
            $("#inpIdSupplier").val("").data("id", "");
        }
    });

    $("#buttonSend").kendoButton({
        click: function() {
            createWaybill(true);
        }
    });

    $("#buttonSave").kendoButton({
        click: function() {
            createWaybill();
        }
    });

    var splitter = $("#splitter").kendoSplitter({
        orientation: "vertical",
        panes: [
            { size: "45%", scrollable: false, collapsible: true, collapsedSize: "20%"},
            { size: "55%", scrollable: false, collapsible: true }
        ]
    }).data("kendoSplitter");
    splitter.wrapper.height(700);
    splitter.resize();

    viewModelWaybill = kendo.observable({
        selectedDocType: 3,
        doctype: [
            { value: 2, name: "Возврат" },
            { value: 3, name: "Расход" }
        ],
        isEnable: true
    });
    kendo.bind($("#formWaybill"), viewModelWaybill);

//    var jsondata = [];
//    for(var i=0; i< 28; i++)
//        jsondata.push({
//            "id_product": i+1,
//            capacity: 100*i + 50,
//            product_v_code: 200 * i,
//            name: (i%2==0) ? "Водка русская" : "Водка столичная",
//            producer_name: (i%6==0) ? "ООО Атлант" :
//                (i%6==1) ? "Ника" :
//                    (i%6==2) ? "Союз" :
//                        (i%6==3) ? "Россия" :
//                            (i%6==4) ? "Путинка" :
//                                "Nemiroff" ,
//            producer_inn: (i%2==0) ? "1234897364": "09462846235",
//            producer_kpp: (i%2==0) ? "6784820942": "46327863286",
//            importer_name: (i%2==0) ? "ТрансАвто" : "ООО Грузовые перевозки",
//            importer_inn: (i%2==0) ? "1123131231": "78497289322",
//            importer_kpp: (i%2==0) ? "9375873493": "78309470223",
//            form_a_reg_id: "NJ-A-3242342342323",
//            form_b_reg_id: ((i+1)%2==0) ? "FT-Y-2468724687234" : "FT-N-21453467566785",
//            qty: (i%10) * 5
////            quantity: (i%10) * 5,
////            price: 0
//
//        });

    var dataSource = new kendo.data.DataSource({
        data: [],
        schema: {
            model: {
                fields: {

                }
            }
        }
    });

    $("#waybillPosListGrid").kendoGrid({
        dataSource: dataSource,
        filterable: false,
        resizable: true,
        sortable: false,
        selectable: "row",
        height: "100%",
        toolbar: "Список позиций ТТН",
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#waybillPosListGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },

            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230 },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? kendo.toString(dataItem.capacity / 1000, "n2") + " л" : "не фас.";
                }
            },
            { field: "currFormARegId", title: "Справка А", width: 210,
                template: function(dataItem) {
                    return dataItem.form_a_reg_id;
                }
            },
            { field: "currFormBRegId", title: "Справка Б", width: 210,
                template: function(dataItem) {
                    return dataItem.form_b_reg_id;
                }
            },
            { field: "posPrice", title: "Цена", width: 130, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.posPrice, "c2") + "/дал") :
                        kendo.toString(dataItem.posPrice, "c2");
                }
            },
            { field: "quantity", title: "Кол-во", width: 90, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.quantity / 10000, "n3") + " дал") :
                        dataItem.quantity;
                }
            },
            { field: "summa", title: "Сумма", format: "{0:c2}", width: 120, filterable: false },
            {
                headerTemplate: "<div class='text-center'>" +
                    "<img class='k-delete-all' width='20' height='20' src='assets/icons/pays/delete.png" +
                    "'></img></div>",
                template: "<div class='text-center'>" +
                    "<img class='k-delete-row' width='20' height='20' src='assets/icons/pays/delete.png" +
                    "'></img></div>",
                width: 40
            }
        ],
        editable: {
            mode: "incell",
            confirmation: false
        },
        edit: function(e) {
//            if (e.model.isNew()) {
                var grid = $("#waybillPosListGrid").data("kendoGrid"),
                    row = grid.select(),
                    dataItem = grid.dataItem(row),
                    value;

                var numeric = e.container.find("input[name=quantity]").data("kendoNumericTextBox");
                if(numeric){
                    var quantity, quantityNew;
                    if(dataItem.product.capacity == 0) {
                        numeric.options.format = "n3";
                        numeric.options.decimals = 3;
                        quantity = dataItem.qty / 10000;

                        quantityNew = dataItem.quantity / 10000;
                        numeric.value(quantityNew);
                    } else {
                        numeric.options.format = "n0";
                        numeric.options.decimals = 0;
                        quantity = dataItem.qty;
                    }

                    numeric.max(quantity);

                    numeric.bind("change", function(){
                        value = this.value() * dataItem.posPrice;
                        dataItem.summa = value;
                        if(dataItem.capacity == 0) {
                            dataItem.quantity  = this.value() * 10000;
                        }
                        grid.saveRow();
                    });
                }

                var numericPrice = e.container.find("input[name=posPrice]").data("kendoNumericTextBox");
                if(numericPrice){
                    var quantityNew;
                    if(dataItem.product.capacity == 0) {
                        quantityNew = dataItem.quantity * 0.0001;
                    } else {
                        quantityNew = dataItem.quantity;
                    }

                    numericPrice.bind("change", function(){
                        value = this.value() * quantityNew;
                        dataItem.summa = value;
                        grid.saveRow();
                    });
                }
//            }
        },
        dataBound: function() {
            var lenght = this.dataSource.data().length;
            $("#buttonSend").data("kendoButton").enable(lenght > 0 ? true : false);

            this.table.find(".k-delete-row").on('click', deleteRow);
        }
    }).data("kendoGrid");

    $(".k-delete-all").click(deleteAll);


    function deleteRow(event) {
        var grid = $("#waybillPosListGrid").data("kendoGrid"),
            row = $(this).closest("tr");

        grid.removeRow(row);
    }
    function deleteAll(event) {
        var grid = $("#waybillPosListGrid").data("kendoGrid");

        var flag = confirm("Вы уверены, что хотите удалить все записи?");
        if(flag) grid.dataSource.data([]);
    }

    $("#waybillPosListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $("#storeListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    id: "id_product",
                    fields: {
                        identity: { editable: false },
                        name: { editable: false },
                        capacity: { editable: false },
                        currFormARegId: { editable: false },
                        currFormBRegId: { editable: false },
                        posPrice: {
                            type: "number",
                            validation: {
                                min: 0
                            }
                        },
                        quantity: {
                            type: "number",
                            validation: {
                                min: 0
                            }
                        },
                        summa: { type: "number", editable: false }
                    }
                }
            }
        },
        filterable: {
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:"
            },
            operators: {
                string: {
                    eq: "Равно",
                    neq: "Не равно",
                    contains: "Содержит",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                }
            },
            extra: false
        },
        resizable: true,
        sortable: true,
        selectable: "row",
        height: "100%",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        toolbar: [
            { template: kendo.template($("#toolbarStoreListGrid").html()) }
        ],
        columns: [
            { field: "id_product", title: "ID", width: 50, filterable: false, hidden: true },
            { field: "product_v_code", title: "Группа", width: 70, filterable: false },
            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230, filterable: true },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? kendo.toString(dataItem.capacity / 1000, "n2") + " л" : "не фас.";
                }
            },
            { field: "producer_name", title: "Производитель", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "producer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "producer_kpp", title: "КПП", width: 120, filterable: true },
            { field: "importer_name", title: "Импортер", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "importer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "importer_kpp", title: "КПП", width: 120, filterable: true },
            { field: "form_a_reg_id", title: "Справка А", width: 210, filterable: true },
            { field: "form_b_reg_id", title: "Справка Б", width: 210, filterable: true },
            { field: "qty", title: "Кол-во", width: 80, filterable: false,
                attributes:{ "class": "table-cell" },
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.qty / 10000, "n3") + " дал") :
                        dataItem.qty;
                }
            },
            {
                template: "<div class='text-center'>" +
                    "<img class='k-plus-row' width='18' height='18' src='assets/icons/pays/plus-icon.png" +
                    "'></img></div>",
                width: 40
            }
        ],
        dataBound: function() {
            this.table.find(".k-plus-row").on('click', addRow);
            this.table.find("tr[data-uid]").dblclick(addRow);
        }
    }).data("kendoGrid");

    function addRow(event) {
        var row = $(this).closest("tr"),
            grid = $("#storeListGrid").data("kendoGrid"),
            dataItem = grid.dataItem(row);

        var index = dataSource.indexOf(dataItem);
        if(index == -1){
            dataItem.quantity = dataItem.qty;
            dataItem.summa = dataItem.sum;
            dataItem.posPrice = dataItem.price;
            dataSource.insert(0, dataItem);
        }
    }

    $("#storeListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $("#inpSearch").keyup(function () {
        filterAllGrid(this, "storeListGrid");
    });

    reloadPersonsList(editDoc);
    reloadStoreList();

    function reloadStoreList(){
        kendo.ui.progress($("#storeListGrid"), true);

        try {
            channel.objects.utm_server.getStore(function (response) {
                kendo.ui.progress($("#storeListGrid"), false);

                var grid = $("#storeListGrid").data("kendoGrid");
                var data = filterOnStoreKind(response.data.store, STOREKIND_STOCK);

                for (var i = 0; i < data.length; i++) {
                    data[i].quantity = data[i].qty;
                    data[i].price = 0;
                    data[i].posPrice = data[i].price;
                    data[i].sum = data[i].qty * data[i].price;
                    data[i].summa = data[i].sum;
                }

                grid.dataSource.data(data);

                if(editFlag)
                    refreshDocPositions(editDoc, data);
            });
        } catch(e) {
            kendo.ui.progress($("#storeListGrid"), false);
            showErrorMessage("Не удалось загрузить состояние склада, попробуйте обновить страницу.");
        }
    }

    validatableFormWaybill = $("#formWaybill").kendoValidator({
        validateOnBlur: false,
        messages: {
            required: function(input){
                return input.data("message");
            }
        }
    }).data("kendoValidator");
}

function refreshControls(editDoc){
    if(!editFlag || (editFlag && (viewModel.operationType == 2)) ) {
        var data = {};
        if (editFlag)
            data.id = viewModel.docId;
        try {
            channel.objects.utm_server.createWaybill(data, function (res) {
                if(res.code == 0) {
                    objCreateWaybill = res.data;

                    viewModelWaybill.set("selectedDocType", objCreateWaybill.docType);
                    if(viewModel.operationType == 2) {
                        viewModelWaybill.set("isEnable", false);
                    }
                    $("#inpNumber").val(objCreateWaybill.number);
                    $("#inpIdConsignee").val((objCreateWaybill.consignee && objCreateWaybill.consignee.shortName) ? objCreateWaybill.consignee.shortName :
                        (objCreateWaybill.consignee && objCreateWaybill.consignee.fullName) ? objCreateWaybill.consignee.fullName : "");
                    $("#inpIdSupplier").val((objCreateWaybill.supplier && objCreateWaybill.supplier.shortName) ? objCreateWaybill.supplier.shortName :
                        (objCreateWaybill.supplier && objCreateWaybill.supplier.fullName) ? objCreateWaybill.supplier.fullName : "");

                    $("#inpBase").val(objCreateWaybill.base);
                    $("#inpComment").val(objCreateWaybill.comment);
                }
                else {
                    showErrorMessage(res.message);
                }
            });
        } catch (e) {
            showErrorMessage("При получении объекта накладной произошла ошибка, попробуйте обновить страницу.");
        }
    } else {
        viewModelWaybill.set("selectedDocType", editDoc.doc_type);

        $("#inpNumber").val(editDoc.doc_num ? editDoc.doc_num : "");

//        получатель
        var consignee = DATA_PERSONS.filter(function(obj) {
            return obj.id == editDoc.id_consignee;
        });
        if(consignee.length > 0) {
            $("#inpIdConsignee").val(consignee[0].name + ", " + consignee[0].address)
                .data("id", consignee[0].id);
        }

//        поставщик
        var supplier = DATA_PERSONS.filter(function(obj) {
            return obj.id == editDoc.id_supplier;
        });
        if(supplier.length > 0) {
            $("#inpIdSupplier").val(supplier[0].name + ", " + supplier[0].address)
                .data("id", supplier[0].id);
        }

        $("#inpBase").val(editDoc.base ? editDoc.base : "");
        $("#inpComment").val(editDoc.comment ? editDoc.comment : "");
    }
}

function refreshDocPositions(editDoc, store){
    try {
        channel.objects.utm_server.getDocPositions(editDoc.doc_id, function (result) {
            var posList = result.data;

            var grid = $("#storeListGrid").data("kendoGrid");
            var posGrid = $("#waybillPosListGrid").data("kendoGrid");

            for (var i = 0; i < posList.length; i++) {
                for (var j = 0; j < store.length; j++) {
                    if (posList[i].curr_form_b_reg_id == store[j].form_b_reg_id &&
                        posList[i].id_product == store[j].id_product) {

                        var dataItem = grid.dataSource.get(store[j].id_product);
                        var index = posGrid.dataSource.indexOf(dataItem);
                        if (index == -1) {
                            dataItem.quantity = Math.min(dataItem.qty, posList[i].qty);
                            dataItem.posPrice = kendo.parseFloat(posList[i].price + "%");
                            dataItem.summa = dataItem.quantity * dataItem.posPrice;
                            posGrid.dataSource.add(dataItem);
                        }

                        break;
                    }
                }
            }
        });
    } catch(e) {
        showErrorMessage("Не удалось загрузить список позиций накладной, попробуйте обновить страницу.");
    }
}

function createWaybill(sendFlag){
    if (validatableFormWaybill.validateInput($("input[name=number]")) &
        validatableFormWaybill.validateInput($("input[name=idConsignee]"))) {
        hideAlerts();

        var inpDate = $("#inpDate").data("kendoDatePicker");
        var inpShipDate = $("#inpShipDate").data("kendoDatePicker");

        var posList = parseDataSourceGrid($("#waybillPosListGrid").data("kendoGrid").dataSource.data());

        objWaybill = {
            docType: viewModelWaybill.get("selectedDocType"),
            number: $("#inpNumber").val(),
            date: new Date(inpDate.value()).toISOString(),
            shipDate: new Date(inpShipDate.value()).toISOString(),
            base: $("#inpBase").val(),
            comment: $("#inpComment").val(),
            positions: posList
        };

        if(sendFlag) {
            confirmMessageDialog.open().center();

            var viewModelConfirmDialog = kendo.observable({
                message: "После отправки в УТМ накладная будет недоступна для редактирования.",
                cancel: function () {
                    confirmMessageDialog.close();
                },
                continue: function () {
                    confirmMessageDialog.close();
                    creatingWaybill(true);
                }
            });
            kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);

        } else {
            creatingWaybill();
        }

    } else {
        showWarningMessage("Не заполнены обязательные поля.");
    }
}

function creatingWaybill(sendFlag){
    showProcessAlert((sendFlag ? "Отправка" : "Сохранение") + " накладной");
    if(sendFlag)
        $("#buttonSend").button('loading');
    else
        $("#buttonSave").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    if(!editFlag || (editFlag && (viewModel.operationType == 2)) ) {
        $.extend(objCreateWaybill, objWaybill);
        objWaybill = objCreateWaybill;

        var idConsignee = $("#inpIdConsignee").data("id");
        var idSupplier = $("#inpIdSupplier").data("id");
        if(idConsignee) {
            var temp = DATA_PERSONS.filter(function(obj) {
                return obj.id == idConsignee;
            });
            objWaybill.consignee = {
                id: temp[0].id,
                inn: temp[0].inn,
                kpp: temp[0].kpp,
                clientRegId: temp[0]["client_reg_id"],
                fullName: "",
                shortName: temp[0].name,
                addressDescription: temp[0].address
            };
        }
        if(idSupplier) {
            var temp = DATA_PERSONS.filter(function(obj) {
                return obj.id == idSupplier;
            });
            objWaybill.supplier = {
                id: temp[0].id,
                inn: temp[0].inn,
                kpp: temp[0].kpp,
                clientRegId: temp[0]["client_reg_id"],
                fullName: "",
                shortName: temp[0].name,
                addressDescription: temp[0].address
            };
        }
    } else {
        objWaybill.id = viewModel.docId;
        objWaybill.idConsignee = $("#inpIdConsignee").data("id");
        objWaybill.idSupplier = $("#inpIdSupplier").data("id");
    }

    saveWaybill(sendFlag);
};

function saveWaybill(sendFlag){
    try {
        channel.objects.utm_server.saveWaybillDraft(objWaybill, function(res){
            if(sendFlag){
                var id = res.data.id;
                try {
                    channel.objects.utm_server.sendWaybill(id, function (result) {
                        hideAlerts();

                        if (result.code == 0) {
                            if (result.data.deferred && result.data.deferred == 1)
                                showWarningMessage("Утм в данный момент недоступен. Накладная поставлена в очередь. Отправится, когда заработает утм.");
                            else {
                                api.setView('EgaisTtnListView');
                                showEgaisTtnListView();
                                showSuccessMessage("Накладная успешно отправлена.");
                            }
                        }
                        else {
                            showErrorMessage(result.message);
                        }
                    });
                } catch(e) {
                    showErrorMessage("При отправке накладной произошла ошибка, попробуйте обновить страницу.");
                    hideAlerts();
                } finally {
                    clearInterval(timerId);
                    $("#buttonSend").button('reset');
                }
            } else {
                hideAlerts();

                if(res.code == 0) {
                    api.setView('EgaisTtnListView');
                    showEgaisTtnListView();
                    showSuccessMessage("Накладная успешно сохранена.");
                }
                else {
                    showErrorMessage(res.message);
                }
            }
        });
    } catch (e) {
        if(sendFlag) {
            showErrorMessage("При отправке накладной произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();

            clearInterval(timerId);
            $("#buttonSend").button('reset');
        } else {
            showErrorMessage("При сохранении накладной произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();
        }
    } finally {
        if(!sendFlag) {
            clearInterval(timerId);
            $("#buttonSave").button('reset');
        }
    }
}

function reloadPersonsList(editDoc){
    try {
        channel.objects.utm_server.getPersons(function (result) {
            if(result.code == 0) {
                DATA_PERSONS = result.data;
                refreshControls(editDoc);
            }
            else {
                showErrorMessage(result.message);
            }
        });
    } catch(e) {
        showErrorMessage("Не удалось загрузить список контрагентов.");
    }
}

function parseDataSourceGrid(data){
    var result = [];
    for (var i = 0; i < data.length; i++) {
        result.push({
            identity: i+1,
            quantity: data[i].quantity,
            price: Math.round(data[i].posPrice * 100),
            currFormARegId: data[i].form_a_reg_id,
            currFormBRegId: data[i].form_b_reg_id,
            idProduct: data[i].id_product
        });
    }
    return result;
}